using Microsoft.Scripting;
using Microsoft.Scripting.Ast;
using Microsoft.Scripting.Runtime;

namespace MyL.Parser.AST {

	class MyLBinary :MyLExpression {

			private readonly int _op;
			private readonly MyLExpression _left;
			private readonly MyLExpression _right;

			public MyLBinary(SourceSpan span, int op, MyLExpression left, MyLExpression right)
				: base(span) {
				_op = op;
				_left = left;
				_right = right;
			}

			protected internal override Expression Generate() {
				Expression left = _left.Generate();
				Expression right = _right.Generate();

				Operators op;
				switch (_op) {
					case TestLexerLexer.PLUS: op = Operators.Add; break;
					case TestLexerLexer.MINUS: op = Operators.Subtract; break;
					case TestLexerLexer.MULTIPLY: op = Operators.Multiply; break;
					case TestLexerLexer.DIVIDE: op = Operators.Divide; break;
					default:
						throw new System.InvalidOperationException();
				}
				return Ast.Action.Operator(op, typeof(object), left, right);
			}
		}

	}
