﻿using Microsoft.Scripting;
using Microsoft.Scripting.Ast;
using Microsoft.Scripting.Runtime;

namespace MyL.Parser.AST {

	class MyLUnary : MyLExpression {

		private readonly int _op;
		private readonly MyLExpression _arg;

		public MyLUnary(SourceSpan span, int op, MyLExpression arg)
			: base(span) {
			_op = op;
			_arg = arg;
		}

		protected internal override Expression Generate() {
			Expression arg = _arg.Generate();

			Operators op;
			switch (_op) {
				case TestLexerLexer.UNARY_PLUS: 
                    op = Operators.Positive;
                    break;
				case TestLexerLexer.UNARY_MINUS: 
                    op = Operators.Negate; 
                    break;
				default:
					throw new System.InvalidOperationException();
			}
			return Ast.Action.Operator(op, typeof(object), arg);
		}
	}

}
