using System;
using System.Collections.Generic;
using System.Text;

namespace MyL.Parser {

	class MyLLexicalAnalyser {

		public enum Tokens {
			PLUS = 4,
			MINUS = 5,
			MULTIPLY = 6,
			DIVIDE = 7
		};

		public static MyLToken GetToken(ref string s) {
			string lex = "";
			TokenType type = TokenType.Empty;

			if (string.IsNullOrEmpty(s)) return MyLToken.Empty;

			while (s.Length > 0 && char.IsWhiteSpace(s[0])) {
				s = s.Substring(1);
			}
			if (string.IsNullOrEmpty(s)) return MyLToken.Empty;

			//Char
			if (char.IsDigit(s[0])) {
				while (s.Length > 0 && char.IsDigit(s[0])) {
					lex = lex + s[0];
					s = s.Substring(1);
				}
				type = TokenType.Number;
			}
				//Symbol
			  else {
				lex = lex + s[0];
				s = s.Substring(1);
				type = TokenType.Symbol;
			}

			return new MyLToken(lex, type);
		}
	}
}
