using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;
using Microsoft.Scripting.Ast;
using MyL.Parser.AST;
using Antlr.Runtime;
using Antlr.Runtime.Tree;

namespace MyL.Parser {

	class MyLParser {
		private string _text;

		public MyLParser(string text) {
			_text = text;
		}

		public MyLStatement ParseCode() {
			CommonTokenStream tokenStream;
			CommonTree t;
			TestLexerLexer lexer;
			TestParserParser parser;
			CommonTreeNodeStream nodes;
			TestTree walker;
			MyLStatement s;

			s = null;
			try {
				lexer = new TestLexerLexer(new ANTLRStringStream(_text));
				tokenStream = new CommonTokenStream(lexer);
				parser = new TestParserParser(tokenStream);
				TestParserParser.prog_return r = parser.prog();
				t = (CommonTree)r.Tree;
				nodes = new CommonTreeNodeStream(t);
				walker = new TestTree(nodes);
				s = walker.prog();
			} catch (Exception ex) {
				Console.WriteLine(ex.Message);
			}

			return s;
		}
	}
}
