/*

MyL parser

version 1.00	01-Feb-2008
	
*/

parser grammar TestParser;
options {
    language = CSharp;
	output = AST;
	tokenVocab = TestLexer;
	ASTLabelType = CommonTree;
}

@namespace { MyL.Parser.AST }

@header {   
    // turn of unreachable code warnings
    // turn off obsolete code warnings
    // turn off unused variable
    # pragma warning disable 0162,0618,0219 
	using System.Text;
}

prog
	: expr NEWLINE! EOF!
	;
	
expr
	: multExpr ((PLUS|MINUS)^ multExpr)*
	;
	
multExpr
	: unaryExpr ((MULTIPLY|DIVIDE)^ unaryExpr)*
	;

unaryExpr
    : PLUS primary -> ^(UNARY_PLUS primary )
    | MINUS primary -> ^(UNARY_MINUS primary )
	| primary
	;
	
primary
	: INT
	| LPAREN! expr RPAREN!
	;
