/*

MyL tree grammar

version 1.00	01-Feb-2008
	
*/

tree grammar TestTree;

options {
	tokenVocab=TestParser;
	ASTLabelType = CommonTree;
    language = CSharp;
}

@namespace { MyL.Parser.AST }

@header {   
    // turn of unreachable code warnings
    // turn off obsolete code warnings
    // turn off unused variable
    # pragma warning disable 0162,0618,0219 
	using Microsoft.Scripting;
}

prog returns [MyLStatement result]
	: e=expr  {$result = new MyLPrint(e.Span, e);}
	;

expr returns [MyLExpression result]
	: ^(op=(PLUS|MINUS|MULTIPLY|DIVIDE) left=expr right=expr) {$result = new MyLBinary(new SourceSpan(), op.Token.Type, left, right);}
	| ^(op=(UNARY_PLUS|UNARY_MINUS) arg=expr) {$result = new MyLUnary(new SourceSpan(), op.Token.Type, arg);}
	| INT {$result = new MyLConstant(new SourceSpan(), double.Parse($INT.Text));}
	;