using Microsoft.Scripting.Shell;

namespace Microsoft.Scripting.Runtime {

	public class DefaultOptionsParser : OptionsParser {

		private ConsoleOptions _consoleOptions;
		private EngineOptions _engineOptions;

		public override ConsoleOptions ConsoleOptions {
			get { return _consoleOptions; }
			set { _consoleOptions = value; }
		}
		public override EngineOptions EngineOptions {
			get { return _engineOptions; }
			set { _engineOptions = value; }
		}

		public DefaultOptionsParser(LanguageContext context):base(context) {
		}

		public override void Parse(string[] args) {
			if (_consoleOptions == null) _consoleOptions = GetDefaultConsoleOptions();
			if (_engineOptions == null) _engineOptions = GetDefaultEngineOptions();

			base.Parse(args);
		}

	}
}