/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Public License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Public License, please send an email to 
 * dlr@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Public License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

namespace Microsoft.Scripting.Ast {
    /// <summary>
    /// Walker class - The DLR AST Walker
    /// </summary>
    partial class Walker {

        #region Generated DLR AST Walker

        // *** BEGIN GENERATED CODE ***
        // generated by function: gen_scripting_walker from: generate_tree.py

        // ActionExpression
        protected internal virtual bool Walk(ActionExpression node) { return true; }
        protected internal virtual void PostWalk(ActionExpression node) { }

        // ArrayIndexAssignment
        protected internal virtual bool Walk(ArrayIndexAssignment node) { return true; }
        protected internal virtual void PostWalk(ArrayIndexAssignment node) { }

        // BinaryExpression
        protected internal virtual bool Walk(BinaryExpression node) { return true; }
        protected internal virtual void PostWalk(BinaryExpression node) { }

        // Block
        protected internal virtual bool Walk(Block node) { return true; }
        protected internal virtual void PostWalk(Block node) { }

        // BoundAssignment
        protected internal virtual bool Walk(BoundAssignment node) { return true; }
        protected internal virtual void PostWalk(BoundAssignment node) { }

        // BoundExpression
        protected internal virtual bool Walk(BoundExpression node) { return true; }
        protected internal virtual void PostWalk(BoundExpression node) { }

        // BreakStatement
        protected internal virtual bool Walk(BreakStatement node) { return true; }
        protected internal virtual void PostWalk(BreakStatement node) { }

        // CodeBlockExpression
        protected internal virtual bool Walk(CodeBlockExpression node) { return true; }
        protected internal virtual void PostWalk(CodeBlockExpression node) { }

        // ConditionalExpression
        protected internal virtual bool Walk(ConditionalExpression node) { return true; }
        protected internal virtual void PostWalk(ConditionalExpression node) { }

        // ConstantExpression
        protected internal virtual bool Walk(ConstantExpression node) { return true; }
        protected internal virtual void PostWalk(ConstantExpression node) { }

        // ContinueStatement
        protected internal virtual bool Walk(ContinueStatement node) { return true; }
        protected internal virtual void PostWalk(ContinueStatement node) { }

        // DeleteStatement
        protected internal virtual bool Walk(DeleteStatement node) { return true; }
        protected internal virtual void PostWalk(DeleteStatement node) { }

        // DeleteUnboundExpression
        protected internal virtual bool Walk(DeleteUnboundExpression node) { return true; }
        protected internal virtual void PostWalk(DeleteUnboundExpression node) { }

        // DoStatement
        protected internal virtual bool Walk(DoStatement node) { return true; }
        protected internal virtual void PostWalk(DoStatement node) { }

        // EmptyStatement
        protected internal virtual bool Walk(EmptyStatement node) { return true; }
        protected internal virtual void PostWalk(EmptyStatement node) { }

        // ExpressionStatement
        protected internal virtual bool Walk(ExpressionStatement node) { return true; }
        protected internal virtual void PostWalk(ExpressionStatement node) { }

        // IntrinsicExpression
        protected internal virtual bool Walk(IntrinsicExpression node) { return true; }
        protected internal virtual void PostWalk(IntrinsicExpression node) { }

        // LabeledStatement
        protected internal virtual bool Walk(LabeledStatement node) { return true; }
        protected internal virtual void PostWalk(LabeledStatement node) { }

        // LoopStatement
        protected internal virtual bool Walk(LoopStatement node) { return true; }
        protected internal virtual void PostWalk(LoopStatement node) { }

        // MemberAssignment
        protected internal virtual bool Walk(MemberAssignment node) { return true; }
        protected internal virtual void PostWalk(MemberAssignment node) { }

        // MemberExpression
        protected internal virtual bool Walk(MemberExpression node) { return true; }
        protected internal virtual void PostWalk(MemberExpression node) { }

        // MethodCallExpression
        protected internal virtual bool Walk(MethodCallExpression node) { return true; }
        protected internal virtual void PostWalk(MethodCallExpression node) { }

        // NewArrayExpression
        protected internal virtual bool Walk(NewArrayExpression node) { return true; }
        protected internal virtual void PostWalk(NewArrayExpression node) { }

        // NewExpression
        protected internal virtual bool Walk(NewExpression node) { return true; }
        protected internal virtual void PostWalk(NewExpression node) { }

        // ReturnStatement
        protected internal virtual bool Walk(ReturnStatement node) { return true; }
        protected internal virtual void PostWalk(ReturnStatement node) { }

        // ScopeStatement
        protected internal virtual bool Walk(ScopeStatement node) { return true; }
        protected internal virtual void PostWalk(ScopeStatement node) { }

        // SwitchStatement
        protected internal virtual bool Walk(SwitchStatement node) { return true; }
        protected internal virtual void PostWalk(SwitchStatement node) { }

        // ThrowStatement
        protected internal virtual bool Walk(ThrowStatement node) { return true; }
        protected internal virtual void PostWalk(ThrowStatement node) { }

        // TryStatement
        protected internal virtual bool Walk(TryStatement node) { return true; }
        protected internal virtual void PostWalk(TryStatement node) { }

        // TypeBinaryExpression
        protected internal virtual bool Walk(TypeBinaryExpression node) { return true; }
        protected internal virtual void PostWalk(TypeBinaryExpression node) { }

        // UnaryExpression
        protected internal virtual bool Walk(UnaryExpression node) { return true; }
        protected internal virtual void PostWalk(UnaryExpression node) { }

        // UnboundAssignment
        protected internal virtual bool Walk(UnboundAssignment node) { return true; }
        protected internal virtual void PostWalk(UnboundAssignment node) { }

        // UnboundExpression
        protected internal virtual bool Walk(UnboundExpression node) { return true; }
        protected internal virtual void PostWalk(UnboundExpression node) { }

        // YieldStatement
        protected internal virtual bool Walk(YieldStatement node) { return true; }
        protected internal virtual void PostWalk(YieldStatement node) { }

        // CatchBlock
        protected internal virtual bool Walk(CatchBlock node) { return true; }
        protected internal virtual void PostWalk(CatchBlock node) { }

        // LambdaExpression
        protected internal virtual bool Walk(LambdaExpression node) { return true; }
        protected internal virtual void PostWalk(LambdaExpression node) { }

        // GeneratorCodeBlock
        protected internal virtual bool Walk(GeneratorCodeBlock node) { return true; }
        protected internal virtual void PostWalk(GeneratorCodeBlock node) { }

        // IfStatementTest
        protected internal virtual bool Walk(IfStatementTest node) { return true; }
        protected internal virtual void PostWalk(IfStatementTest node) { }

        // SwitchCase
        protected internal virtual bool Walk(SwitchCase node) { return true; }
        protected internal virtual void PostWalk(SwitchCase node) { }

        // *** END GENERATED CODE ***

        #endregion

    }
}
